module Async
  module Messaging
    module Controller

      # collect all flash notifications from a given user
      def notify_flash(user)
        return if user.nil?
        rs = Mongoid::Message.where(to: user.id, category: :flash)
        # collect results (copy)
        ret = rs.to_a
        # remove from the database
        rs.delete_all
        # return the collected results
        ret
      end

      # controller helper
      def self.included(base)
        base.before_filter :help_async_messaging
      end
      # before filter that creates flash messages
      def help_async_messaging
        # push flash_notices to flash.now
        flash_notices = notify_flash(User.current).flat_map(&:to_h)
        flash.now[:async_messaging] ||= []
        flash.now[:async_messaging].concat flash_notices
      end

    end
  end
end