# encoding: utf-8

module Async
  module Messaging
    module Mongoid
      class Message

        include ::Mongoid::Document
        include ::Mongoid::Timestamps

        field :from, type: String
        field :to, type: String
        field :date_read, type: Array
        field :priority, type: Integer, default: 0

        field :subject, type: String
        field :content, type: String

        field :category, type: String
        field :flags, type: Array

        def to_h
          Hash[self.attributes].symbolize_keys
        end

      end
    end
  end
end